/*
 * Copyright (C) ExBin Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package pers.ui.basic;


import org.exbin.deltahex.Section;
import org.exbin.deltahex.swing.CodeArea;


/**
 * Hexadecimal editor example panel.
 *
 * @version 0.1.3 2017/03/02
 * @author ExBin Project (http://exbin.org)
 */
public class DeltaHexPanel extends javax.swing.JPanel {

    private CodeArea codeArea;
    public DeltaHexPanel() {
        initComponents();
    }

    public void setCodeArea(final CodeArea codeArea) {
        this.codeArea = codeArea;
        splitPane.setRightComponent(codeArea);


        showShadowCursorCheckBox.setSelected(codeArea.isShowShadowCursor());

        wrapLineModeCheckBox.setSelected(codeArea.isWrapMode());
        lineLengthSpinner.setValue(codeArea.getLineLength());
        dataSizeTextField.setText(String.valueOf(codeArea.getDataSize()));
  



    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        //
//new javax.swing.JPanel();
//        new javax.swing.JLabel();
        dataSizeTextField = new javax.swing.JTextField();

//        new javax.swing.JPanel();
//        new javax.swing.JLabel();
//        new javax.swing.JTextField();
//        new javax.swing.JLabel();
//        new javax.swing.JTextField();
//        new javax.swing.JLabel();
        activeSectionComboBox = new javax.swing.JComboBox<>();
//        new javax.swing.JPanel();
//        new javax.swing.JLabel();
//        new javax.swing.JTextField();
//        new javax.swing.JLabel();
//        new javax.swing.JTextField();
//        new javax.swing.JPanel();
//        new javax.swing.JLabel();
        lineLengthSpinner = new javax.swing.JSpinner();
//        new javax.swing.JPanel();
//        new javax.swing.JCheckBox();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JSpinner();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JSpinner();
        wrapLineModeCheckBox = new javax.swing.JCheckBox();
//        new javax.swing.JPanel();
//        new javax.swing.JCheckBox();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JSpinner();
//        new javax.swing.JLabel();
//        new javax.swing.JSpinner();
//        new javax.swing.JLabel();
//        new javax.swing.JSpinner();
//        new javax.swing.JPanel();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JCheckBox();
//        new javax.swing.JPanel();
//        new javax.swing.JCheckBox();
//        new javax.swing.JCheckBox();
//        new javax.swing.JCheckBox();
//        new javax.swing.JCheckBox();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JPanel();
//        new javax.swing.JPanel();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JLabel();
//        new javax.swing.JTextField();
//        new javax.swing.JPanel();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JLabel();
//        new javax.swing.JTextField();
//        new javax.swing.JLabel();
        showShadowCursorCheckBox = new javax.swing.JCheckBox();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JLabel();
//        new javax.swing.JComboBox<>();
//        new javax.swing.JLabel();
//        new javax.swing.JSpinner();
        splitPane = new javax.swing.JSplitPane();
        tabbedPane = new javax.swing.JTabbedPane();
       

    
        
        // ****************************************************************
        //������������������,��ϵ���ܷ�ѡ���޸ĵĲ���
        //activeSectionComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "CODE_MATRIX", "TEXT_PREVIEW" }));
        activeSectionComboBox.setModel(new javax.swing.DefaultComboBoxModel<>());
        activeSectionComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                activeSectionComboBoxActionPerformed(evt);
            }
        });

       // ****************************************************************
        
        

        setLayout(new java.awt.BorderLayout());


        
        
        
        
		splitPane.setEnabled(false);
		splitPane.setDividerSize(0);//设置分隔条的宽度
        splitPane.setLeftComponent(tabbedPane);

        add(splitPane, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents
    
//****************************************************************************
//   ����ȥ        �����¼�  ʵ�ֽӿں���
    private void activeSectionComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_activeSectionComboBoxActionPerformed
        codeArea.setActiveSection(Section.values()[activeSectionComboBox.getSelectedIndex()]);
    }//GEN-LAST:event_activeSectionComboBoxActionPerformed
  //****************************************************************************
//   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> activeSectionComboBox;
    private javax.swing.JTextField dataSizeTextField;
    private javax.swing.JSpinner lineLengthSpinner;
    private javax.swing.JCheckBox showShadowCursorCheckBox;
    private javax.swing.JSplitPane splitPane;
    private javax.swing.JTabbedPane tabbedPane;
    private javax.swing.JCheckBox wrapLineModeCheckBox;
    // End of variables declaration//GEN-END:variables
}
